Exclude auto-generated Haskell code from coverage
[ganeti-local] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Use bash in order to be able to use pipefail
13 SHELL=/bin/bash
14
15 ACLOCAL_AMFLAGS = -I autotools
16 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
17 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
18 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
19 CHECK_MAN = $(top_srcdir)/autotools/check-man
20 CHECK_VERSION = $(top_srcdir)/autotools/check-version
21 CHECK_NEWS = $(top_srcdir)/autotools/check-news
22 DOCPP = $(top_srcdir)/autotools/docpp
23 REPLACE_VARS_SED = autotools/replace_vars.sed
24 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
25
26 # Note: these are automake-specific variables, and must be named after
27 # the directory + 'dir' suffix
28 clientdir = $(pkgpythondir)/client
29 hypervisordir = $(pkgpythondir)/hypervisor
30 httpdir = $(pkgpythondir)/http
31 masterddir = $(pkgpythondir)/masterd
32 confddir = $(pkgpythondir)/confd
33 rapidir = $(pkgpythondir)/rapi
34 serverdir = $(pkgpythondir)/server
35 watcherdir = $(pkgpythondir)/watcher
36 impexpddir = $(pkgpythondir)/impexpd
37 utilsdir = $(pkgpythondir)/utils
38 toolsdir = $(pkglibdir)/tools
39 iallocatorsdir = $(pkglibdir)/iallocators
40 pytoolsdir = $(pkgpythondir)/tools
41 docdir = $(datadir)/doc/$(PACKAGE)
42
43 # Delete output file if an error occurred while building it
44 .DELETE_ON_ERROR:
45
46 HTOOLS_DIRS = \
47         htools \
48         htools/Ganeti \
49         htools/Ganeti/HTools
50
51 DIRS = \
52         autotools \
53         daemons \
54         devel \
55         doc \
56         doc/examples \
57         doc/examples/hooks \
58         doc/examples/gnt-debug \
59         $(HTOOLS_DIRS) \
60         lib \
61         lib/client \
62         lib/build \
63         lib/confd \
64         lib/http \
65         lib/hypervisor \
66         lib/impexpd \
67         lib/masterd \
68         lib/rapi \
69         lib/server \
70         lib/tools \
71         lib/utils \
72         lib/watcher \
73         man \
74         qa \
75         test \
76         test/data \
77         tools
78
79 BUILDTIME_DIR_AUTOCREATE = \
80         scripts \
81         $(APIDOC_DIR) \
82         $(APIDOC_PY_DIR) \
83         $(APIDOC_HS_DIR) \
84         $(APIDOC_HS_DIR)/Ganeti $(APIDOC_HS_DIR)/Ganeti/HTools \
85         $(COVERAGE_DIR) \
86         $(COVERAGE_PY_DIR) \
87         $(COVERAGE_HS_DIR) \
88         .hpc
89
90 BUILDTIME_DIRS = \
91         $(BUILDTIME_DIR_AUTOCREATE) \
92         doc/html
93
94 DIRCHECK_EXCLUDE = \
95         $(BUILDTIME_DIRS) \
96         ganeti-[0-9]*.[0-9]*.[0-9]* \
97         doc/html/_*
98
99 all_dirfiles = $(addsuffix /.dir,$(DIRS) $(BUILDTIME_DIR_AUTOCREATE))
100
101 # some helper vars
102 COVERAGE_DIR = doc/coverage
103 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
104 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
105 APIDOC_DIR = doc/api
106 APIDOC_PY_DIR = $(APIDOC_DIR)/py
107 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
108
109 MAINTAINERCLEANFILES = \
110         $(docpng) \
111         $(maninput) \
112         doc/install-quick.rst \
113         doc/news.rst \
114         doc/upgrade.rst \
115         vcs-version
116
117 maintainer-clean-local:
118         rm -rf $(BUILDTIME_DIRS)
119
120 CLEANFILES = \
121         $(addsuffix /*.py[co],$(DIRS)) \
122         $(addsuffix /*.hi,$(HTOOLS_DIRS)) \
123         $(addsuffix /*.o,$(HTOOLS_DIRS)) \
124         $(all_dirfiles) \
125         $(PYTHON_BOOTSTRAP) \
126         epydoc.conf \
127         autotools/replace_vars.sed \
128         daemons/daemon-util \
129         daemons/ganeti-cleaner \
130         devel/upload \
131         doc/examples/bash_completion \
132         doc/examples/ganeti.initd \
133         doc/examples/ganeti-kvm-poweroff.initd \
134         doc/examples/ganeti.cron \
135         doc/examples/gnt-config-backup \
136         doc/examples/hooks/ipsec \
137         $(man_MANS) \
138         $(manhtml) \
139         tools/kvm-ifup \
140         stamp-srclinks \
141         $(nodist_pkgpython_PYTHON) \
142         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
143         .hpc/*.mix htools/*.tix \
144         doc/hs-lint.html
145
146 # BUILT_SOURCES should only be used as a dependency on phony targets. Otherwise
147 # it'll cause the target to rebuild every time.
148 BUILT_SOURCES = \
149         ganeti \
150         stamp-srclinks \
151         lib/_autoconf.py \
152         $(all_dirfiles) \
153         $(PYTHON_BOOTSTRAP)
154
155 nodist_pkgpython_PYTHON = \
156         lib/_autoconf.py
157
158 noinst_PYTHON = \
159         lib/build/__init__.py \
160         lib/build/sphinx_ext.py
161
162 pkgpython_PYTHON = \
163         lib/__init__.py \
164         lib/asyncnotifier.py \
165         lib/backend.py \
166         lib/bdev.py \
167         lib/bootstrap.py \
168         lib/cli.py \
169         lib/cmdlib.py \
170         lib/compat.py \
171         lib/config.py \
172         lib/constants.py \
173         lib/daemon.py \
174         lib/errors.py \
175         lib/ht.py \
176         lib/jqueue.py \
177         lib/jstore.py \
178         lib/locking.py \
179         lib/luxi.py \
180         lib/mcpu.py \
181         lib/netutils.py \
182         lib/objects.py \
183         lib/opcodes.py \
184         lib/qlang.py \
185         lib/query.py \
186         lib/rpc.py \
187         lib/runtime.py \
188         lib/serializer.py \
189         lib/ssconf.py \
190         lib/ssh.py \
191         lib/storage.py \
192         lib/uidpool.py \
193         lib/workerpool.py
194
195 client_PYTHON = \
196         lib/client/__init__.py \
197         lib/client/gnt_backup.py \
198         lib/client/gnt_cluster.py \
199         lib/client/gnt_debug.py \
200         lib/client/gnt_group.py \
201         lib/client/gnt_instance.py \
202         lib/client/gnt_job.py \
203         lib/client/gnt_node.py \
204         lib/client/gnt_os.py
205
206 hypervisor_PYTHON = \
207         lib/hypervisor/__init__.py \
208         lib/hypervisor/hv_base.py \
209         lib/hypervisor/hv_chroot.py \
210         lib/hypervisor/hv_fake.py \
211         lib/hypervisor/hv_kvm.py \
212         lib/hypervisor/hv_lxc.py \
213         lib/hypervisor/hv_xen.py
214
215 rapi_PYTHON = \
216         lib/rapi/__init__.py \
217         lib/rapi/baserlib.py \
218         lib/rapi/client.py \
219         lib/rapi/client_utils.py \
220         lib/rapi/connector.py \
221         lib/rapi/rlib2.py
222
223 http_PYTHON = \
224         lib/http/__init__.py \
225         lib/http/auth.py \
226         lib/http/client.py \
227         lib/http/server.py
228
229 confd_PYTHON = \
230         lib/confd/__init__.py \
231         lib/confd/client.py \
232         lib/confd/querylib.py \
233         lib/confd/server.py
234
235 masterd_PYTHON = \
236         lib/masterd/__init__.py \
237         lib/masterd/instance.py
238
239 impexpd_PYTHON = \
240         lib/impexpd/__init__.py
241
242 watcher_PYTHON = \
243         lib/watcher/__init__.py
244
245 server_PYTHON = \
246         lib/server/__init__.py \
247         lib/server/confd.py \
248         lib/server/masterd.py \
249         lib/server/noded.py \
250         lib/server/rapi.py
251
252 pytools_PYTHON = \
253         lib/tools/__init__.py \
254         lib/tools/ensure_dirs.py
255
256 utils_PYTHON = \
257         lib/utils/__init__.py \
258         lib/utils/algo.py \
259         lib/utils/filelock.py \
260         lib/utils/hash.py \
261         lib/utils/io.py \
262         lib/utils/log.py \
263         lib/utils/mlock.py \
264         lib/utils/nodesetup.py \
265         lib/utils/process.py \
266         lib/utils/retry.py \
267         lib/utils/text.py \
268         lib/utils/wrapper.py \
269         lib/utils/x509.py
270
271 docrst = \
272         doc/admin.rst \
273         doc/design-2.0.rst \
274         doc/design-2.1.rst \
275         doc/design-2.2.rst \
276         doc/design-2.3.rst \
277         doc/design-htools-2.3.rst \
278         doc/design-2.4.rst \
279         doc/design-draft.rst \
280         doc/design-oob.rst \
281         doc/design-cpu-pinning.rst \
282         doc/design-query2.rst \
283         doc/design-x509-ca.rst \
284         doc/design-http-server.rst \
285         doc/design-impexp2.rst \
286         doc/design-lu-generated-jobs.rst \
287         doc/design-multi-reloc.rst \
288         doc/design-network.rst \
289         doc/cluster-merge.rst \
290         doc/design-shared-storage.rst \
291         doc/devnotes.rst \
292         doc/glossary.rst \
293         doc/hooks.rst \
294         doc/iallocator.rst \
295         doc/index.rst \
296         doc/install-quick.rst \
297         doc/install.rst \
298         doc/locking.rst \
299         doc/move-instance.rst \
300         doc/news.rst \
301         doc/rapi.rst \
302         doc/security.rst \
303         doc/upgrade.rst \
304         doc/walkthrough.rst
305
306 HS_PROGS = \
307         htools/hbal \
308         htools/hscan \
309         htools/hail \
310         htools/hspace
311
312 HS_ALL_PROGS = $(HS_PROGS) htools/test
313 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
314 # we don't add -Werror by default
315 HFLAGS = -O -Wall -fwarn-monomorphism-restriction -fwarn-tabs -ihtools
316 # extra flags that can be overriden on the command line
317 HEXTRA =
318 # exclude options for coverage reports
319 HPCEXCL = --exclude Main --exclude Ganeti.HTools.QC \
320         --exclude Ganeti.Constants \
321         --exclude Ganeti.HTools.Version
322
323 HS_LIB_SRCS = \
324         htools/Ganeti/HTools/CLI.hs \
325         htools/Ganeti/HTools/Cluster.hs \
326         htools/Ganeti/HTools/Container.hs \
327         htools/Ganeti/HTools/ExtLoader.hs \
328         htools/Ganeti/HTools/Group.hs \
329         htools/Ganeti/HTools/IAlloc.hs \
330         htools/Ganeti/HTools/Instance.hs \
331         htools/Ganeti/HTools/Loader.hs \
332         htools/Ganeti/HTools/Luxi.hs \
333         htools/Ganeti/HTools/Node.hs \
334         htools/Ganeti/HTools/PeerMap.hs \
335         htools/Ganeti/HTools/QC.hs \
336         htools/Ganeti/HTools/Rapi.hs \
337         htools/Ganeti/HTools/Simu.hs \
338         htools/Ganeti/HTools/Text.hs \
339         htools/Ganeti/HTools/Types.hs \
340         htools/Ganeti/HTools/Utils.hs \
341         htools/Ganeti/Jobs.hs \
342         htools/Ganeti/Luxi.hs \
343         htools/Ganeti/OpCodes.hs
344
345 HS_BUILT_SRCS = htools/Ganeti/HTools/Version.hs htools/Ganeti/Constants.hs
346 HS_BUILT_SRCS_IN = $(patsubst %,%.in,$(HS_BUILT_SRCS))
347
348 $(RUN_IN_TEMPDIR): | $(all_dirfiles)
349
350 # Note: we use here an order-only prerequisite, as the contents of
351 # _autoconf.py are not actually influencing the html build output: it
352 # has to exist in order for the sphinx module to be loaded
353 # successfully, but we certainly don't want the docs to be rebuilt if
354 # it changes
355 doc/html/index.html: $(docrst) $(docpng) doc/conf.py configure.ac \
356         $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py lib/opcodes.py lib/ht.py \
357         | lib/_autoconf.py
358         @test -n "$(SPHINX)" || \
359             { echo 'sphinx-build' not found during configure; exit 1; }
360         @mkdir_p@ $(dir $@)
361         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(SPHINX) -q -W -b html \
362             -d . \
363             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
364             -D release="$(PACKAGE_VERSION)" \
365             $(abs_top_srcdir)/doc $(CURDIR)/doc/html
366         rm -f doc/html/.buildinfo doc/html/objects.inv
367         touch $@
368
369 doc/html: doc/html/index.html
370
371 doc/install-quick.rst: INSTALL
372 doc/news.rst: NEWS
373 doc/upgrade.rst: UPGRADE
374
375 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
376         set -e; \
377         { echo '.. This file is automatically updated at build time from $<.'; \
378           echo '.. Do not edit.'; \
379           echo; \
380           cat $<; \
381         } > $@
382
383 docdot = \
384         doc/arch-2.0.dot \
385         doc/design-2.1-lock-acquire.dot \
386         doc/design-2.1-lock-release.dot
387
388 docpng = $(patsubst %.dot,%.png,$(docdot))
389
390 # Things to build but not to install (add it to EXTRA_DIST if it should be
391 # distributed)
392 noinst_DATA = \
393         devel/upload \
394         doc/html \
395         doc/examples/bash_completion \
396         doc/examples/ganeti.cron \
397         doc/examples/ganeti.initd \
398         doc/examples/ganeti-kvm-poweroff.initd \
399         doc/examples/gnt-config-backup \
400         doc/examples/hooks/ipsec \
401         $(manhtml)
402
403 gnt_scripts = \
404         scripts/gnt-backup \
405         scripts/gnt-cluster \
406         scripts/gnt-debug \
407         scripts/gnt-group \
408         scripts/gnt-instance \
409         scripts/gnt-job \
410         scripts/gnt-node \
411         scripts/gnt-os
412
413 PYTHON_BOOTSTRAP_SBIN = \
414         daemons/ganeti-confd \
415         daemons/ganeti-masterd \
416         daemons/ganeti-noded \
417         daemons/ganeti-watcher \
418         daemons/ganeti-rapi \
419         scripts/gnt-backup \
420         scripts/gnt-cluster \
421         scripts/gnt-debug \
422         scripts/gnt-group \
423         scripts/gnt-instance \
424         scripts/gnt-job \
425         scripts/gnt-node \
426         scripts/gnt-os
427
428 PYTHON_BOOTSTRAP = \
429         $(PYTHON_BOOTSTRAP_SBIN) \
430         tools/ensure-dirs
431
432 qa_scripts = \
433         qa/ganeti-qa.py \
434         qa/qa_cluster.py \
435         qa/qa_config.py \
436         qa/qa_daemon.py \
437         qa/qa_env.py \
438         qa/qa_error.py \
439         qa/qa_instance.py \
440         qa/qa_node.py \
441         qa/qa_os.py \
442         qa/qa_rapi.py \
443         qa/qa_tags.py \
444         qa/qa_utils.py
445
446 bin_SCRIPTS =
447 iallocators_SCRIPTS =
448 if WANT_HTOOLS
449 bin_SCRIPTS += $(filter-out htools/hail,$(HS_PROGS))
450 iallocators_SCRIPTS += $(filter htools/hail,$(HS_PROGS))
451 endif
452
453 $(HS_ALL_PROGS): %: %.hs $(HS_LIB_SRCS) $(HS_BUILT_SRCS) Makefile
454         @if [ -z "$(HTOOLS)" ]; then \
455           echo "Error: htools compilation disabled at configure time" 1>&2 ;\
456           exit 1; \
457         fi
458         @BINARY=$(@:htools/%=%); \
459         if [ "$BINARY" = "test" ] && [ -z "$(GHC_PKG_QUICKCHECK)" ]; then \
460           echo "Error: cannot run unittests without the QuickCheck library (see devnotes.rst)" 1>&2; \
461           exit 1; \
462         fi
463         BINARY=$(@:htools/%=%); $(GHC) --make \
464           $(HFLAGS) $(HEXTRA) $(HTOOLS_NOCURL) \
465           -osuf $$BINARY.o -hisuf $$BINARY.hi $@
466
467 # for the htools/test binary, we need to enable profiling/coverage
468 htools/test: HEXTRA=-fhpc -Wwarn -fno-warn-missing-signatures \
469         -fno-warn-monomorphism-restriction -fno-warn-orphans \
470         -fno-warn-missing-methods -fno-warn-unused-imports
471
472 dist_sbin_SCRIPTS = \
473         tools/ganeti-listrunner
474
475 nodist_sbin_SCRIPTS = \
476         $(PYTHON_BOOTSTRAP_SBIN) \
477         daemons/ganeti-cleaner
478
479 dist_tools_SCRIPTS = \
480         tools/burnin \
481         tools/cfgshell \
482         tools/cfgupgrade \
483         tools/cfgupgrade12 \
484         tools/cluster-merge \
485         tools/lvmstrap \
486         tools/move-instance \
487         tools/setup-ssh \
488         tools/sanitize-config
489
490 pkglib_python_scripts = \
491         daemons/import-export \
492         tools/check-cert-expired
493
494 nodist_pkglib_python_scripts = \
495         tools/ensure-dirs
496
497 pkglib_SCRIPTS = \
498         daemons/daemon-util \
499         tools/kvm-ifup \
500         $(pkglib_python_scripts)
501
502 nodist_pkglib_SCRIPTS = \
503         $(nodist_pkglib_python_scripts)
504
505 EXTRA_DIST = \
506         NEWS \
507         UPGRADE \
508         epydoc.conf.in \
509         pylintrc \
510         autotools/build-bash-completion \
511         autotools/check-python-code \
512         autotools/check-man \
513         autotools/check-news \
514         autotools/check-tar \
515         autotools/check-version \
516         autotools/convert-constants \
517         autotools/docpp \
518         autotools/gen-coverage \
519         autotools/testrunner \
520         $(RUN_IN_TEMPDIR) \
521         daemons/daemon-util.in \
522         daemons/ganeti-cleaner.in \
523         $(pkglib_python_scripts) \
524         devel/upload.in \
525         tools/kvm-ifup.in \
526         $(docdot) \
527         $(docpng) \
528         $(docrst) \
529         doc/conf.py \
530         doc/html \
531         doc/examples/ganeti.initd.in \
532         doc/examples/ganeti-kvm-poweroff.initd.in \
533         doc/examples/ganeti.cron.in \
534         doc/examples/gnt-config-backup.in \
535         doc/examples/ganeti.default \
536         doc/examples/ganeti.default-debug \
537         doc/examples/hooks/ethers \
538         doc/examples/hooks/ipsec.in \
539         doc/examples/gnt-debug/README \
540         doc/examples/gnt-debug/delay0.json \
541         doc/examples/gnt-debug/delay50.json \
542         test/testutils.py \
543         test/mocks.py \
544         $(dist_TESTS) \
545         $(TEST_FILES) \
546         man/footer.rst \
547         $(manrst) \
548         $(maninput) \
549         qa/qa-sample.json \
550         $(qa_scripts) \
551         $(HS_LIB_SRCS) $(HS_BUILT_SRCS_IN) \
552         $(HS_PROG_SRCS)
553
554 man_MANS = \
555         man/ganeti.7 \
556         man/ganeti-cleaner.8 \
557         man/ganeti-confd.8 \
558         man/ganeti-listrunner.8 \
559         man/ganeti-masterd.8 \
560         man/ganeti-noded.8 \
561         man/ganeti-os-interface.7 \
562         man/ganeti-rapi.8 \
563         man/ganeti-watcher.8 \
564         man/gnt-backup.8 \
565         man/gnt-cluster.8 \
566         man/gnt-debug.8 \
567         man/gnt-group.8 \
568         man/gnt-instance.8 \
569         man/gnt-job.8 \
570         man/gnt-node.8 \
571         man/gnt-os.8 \
572         man/hail.1 \
573         man/hbal.1 \
574         man/hscan.1 \
575         man/hspace.1
576
577 manrst = $(patsubst %.1,%.rst,$(patsubst %.7,%.rst,$(patsubst %.8,%.rst,$(man_MANS))))
578 manhtml = $(patsubst %.rst,%.html,$(manrst))
579 mangen = $(patsubst %.rst,%.gen,$(manrst))
580 maninput = \
581         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
582         $(patsubst %.html,%.html.in,$(manhtml)) \
583         man/footer.man man/footer.html $(mangen)
584
585 TEST_FILES = \
586         test/data/bdev-drbd-8.0.txt \
587         test/data/bdev-drbd-8.3.txt \
588         test/data/bdev-drbd-disk.txt \
589         test/data/bdev-drbd-net-ip4.txt \
590         test/data/bdev-drbd-net-ip6.txt \
591         test/data/cert1.pem \
592         test/data/proc_drbd8.txt \
593         test/data/proc_drbd80-emptyline.txt \
594         test/data/proc_drbd83.txt \
595         test/data/sys_drbd_usermode_helper.txt \
596         test/import-export_unittest-helper
597
598 python_tests = \
599         test/ganeti.asyncnotifier_unittest.py \
600         test/ganeti.backend_unittest.py \
601         test/ganeti.bdev_unittest.py \
602         test/ganeti.cli_unittest.py \
603         test/ganeti.client.gnt_cluster_unittest.py \
604         test/ganeti.client.gnt_instance_unittest.py \
605         test/ganeti.daemon_unittest.py \
606         test/ganeti.cmdlib_unittest.py \
607         test/ganeti.compat_unittest.py \
608         test/ganeti.confd.client_unittest.py \
609         test/ganeti.config_unittest.py \
610         test/ganeti.constants_unittest.py \
611         test/ganeti.errors_unittest.py \
612         test/ganeti.hooks_unittest.py \
613         test/ganeti.ht_unittest.py \
614         test/ganeti.http_unittest.py \
615         test/ganeti.hypervisor_unittest.py \
616         test/ganeti.hypervisor.hv_chroot_unittest.py \
617         test/ganeti.hypervisor.hv_fake_unittest.py \
618         test/ganeti.hypervisor.hv_kvm_unittest.py \
619         test/ganeti.hypervisor.hv_lxc_unittest.py \
620         test/ganeti.hypervisor.hv_xen_unittest.py \
621         test/ganeti.impexpd_unittest.py \
622         test/ganeti.jqueue_unittest.py \
623         test/ganeti.locking_unittest.py \
624         test/ganeti.luxi_unittest.py \
625         test/ganeti.masterd.instance_unittest.py \
626         test/ganeti.mcpu_unittest.py \
627         test/ganeti.netutils_unittest.py \
628         test/ganeti.objects_unittest.py \
629         test/ganeti.opcodes_unittest.py \
630         test/ganeti.qlang_unittest.py \
631         test/ganeti.query_unittest.py \
632         test/ganeti.rapi.baserlib_unittest.py \
633         test/ganeti.rapi.client_unittest.py \
634         test/ganeti.rapi.resources_unittest.py \
635         test/ganeti.rapi.rlib2_unittest.py \
636         test/ganeti.rpc_unittest.py \
637         test/ganeti.runtime_unittest.py \
638         test/ganeti.serializer_unittest.py \
639         test/ganeti.ssh_unittest.py \
640         test/ganeti.tools.ensure_dirs_unittest.py \
641         test/ganeti.uidpool_unittest.py \
642         test/ganeti.utils.algo_unittest.py \
643         test/ganeti.utils.filelock_unittest.py \
644         test/ganeti.utils.hash_unittest.py \
645         test/ganeti.utils.io_unittest.py \
646         test/ganeti.utils.log_unittest.py \
647         test/ganeti.utils.mlock_unittest.py \
648         test/ganeti.utils.nodesetup_unittest.py \
649         test/ganeti.utils.process_unittest.py \
650         test/ganeti.utils.retry_unittest.py \
651         test/ganeti.utils.text_unittest.py \
652         test/ganeti.utils.wrapper_unittest.py \
653         test/ganeti.utils.x509_unittest.py \
654         test/ganeti.utils_unittest.py \
655         test/ganeti.workerpool_unittest.py \
656         test/cfgupgrade_unittest.py \
657         test/docs_unittest.py \
658         test/tempfile_fork_unittest.py
659
660 haskell_tests = htools/test
661
662 dist_TESTS = \
663         test/check-cert-expired_unittest.bash \
664         test/daemon-util_unittest.bash \
665         test/ganeti-cleaner_unittest.bash \
666         test/import-export_unittest.bash \
667         $(python_tests)
668
669 nodist_TESTS =
670 if WANT_HTOOLSTESTS
671 nodist_TESTS += $(haskell_tests)
672 endif
673
674 TESTS = $(dist_TESTS) $(nodist_TESTS)
675
676 # Environment for all tests
677 PLAIN_TESTS_ENVIRONMENT = \
678         PYTHONPATH=. TOP_SRCDIR=$(abs_top_srcdir) PYTHON=$(PYTHON) $(RUN_IN_TEMPDIR)
679
680 # Environment for tests run by automake
681 TESTS_ENVIRONMENT = \
682         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
683
684 all_python_code = \
685         $(dist_sbin_SCRIPTS) \
686         $(dist_tools_SCRIPTS) \
687         $(pkglib_python_scripts) \
688         $(nodist_pkglib_python_scripts) \
689         $(python_tests) \
690         $(pkgpython_PYTHON) \
691         $(client_PYTHON) \
692         $(hypervisor_PYTHON) \
693         $(rapi_PYTHON) \
694         $(server_PYTHON) \
695         $(pytools_PYTHON) \
696         $(http_PYTHON) \
697         $(confd_PYTHON) \
698         $(masterd_PYTHON) \
699         $(impexpd_PYTHON) \
700         $(utils_PYTHON) \
701         $(watcher_PYTHON) \
702         $(noinst_PYTHON) \
703         $(qa_scripts)
704
705 srclink_files = \
706         man/footer.rst \
707         test/check-cert-expired_unittest.bash \
708         test/daemon-util_unittest.bash \
709         test/ganeti-cleaner_unittest.bash \
710         test/import-export_unittest.bash \
711         $(all_python_code) \
712         $(HS_LIB_SRCS) $(HS_PROG_SRCS)
713
714 check_python_code = \
715         $(BUILD_BASH_COMPLETION) \
716         $(DOCPP) \
717         $(all_python_code)
718
719 lint_python_code = \
720         ganeti \
721         ganeti/http/server.py \
722         $(dist_sbin_SCRIPTS) \
723         $(dist_tools_SCRIPTS) \
724         $(pkglib_python_scripts) \
725         $(BUILD_BASH_COMPLETION) \
726         $(DOCPP) \
727         $(PYTHON_BOOTSTRAP)
728
729 test/daemon-util_unittest.bash: daemons/daemon-util
730
731 test/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
732
733 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
734         sed -f $(REPLACE_VARS_SED) < $< > $@
735         chmod +x $@
736
737 devel/upload: devel/upload.in $(REPLACE_VARS_SED)
738         sed -f $(REPLACE_VARS_SED) < $< > $@
739         chmod u+x $@
740
741 daemons/%: daemons/%.in $(REPLACE_VARS_SED)
742         sed -f $(REPLACE_VARS_SED) < $< > $@
743         chmod +x $@
744
745 doc/examples/%: doc/examples/%.in $(REPLACE_VARS_SED)
746         sed -f $(REPLACE_VARS_SED) < $< > $@
747
748 doc/examples/hooks/%: doc/examples/hooks/%.in $(REPLACE_VARS_SED)
749         sed -f $(REPLACE_VARS_SED) < $< > $@
750
751 doc/examples/bash_completion: $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
752         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin
753         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_BASH_COMPLETION) > $@
754
755 doc/%.png: doc/%.dot
756         @test -n "$(DOT)" || { echo 'dot' not found during configure; exit 1; }
757         $(DOT) -Tpng -o $@ $<
758
759 man/footer.man: man/footer.rst
760         @test -n "$(PANDOC)" || \
761           { echo 'pandoc' not found during configure; exit 1; }
762         $(PANDOC) -f rst -t man -o $@ $<
763
764 man/footer.html: man/footer.rst
765         @test -n "$(PANDOC)" || \
766           { echo 'pandoc' not found during configure; exit 1; }
767         $(PANDOC) -f rst -t html -o $@ $<
768
769 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py
770         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@
771
772 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.man
773         @test -n "$(PANDOC)" || \
774           { echo 'pandoc' not found during configure; exit 1; }
775         set -o pipefail ; \
776         $(PANDOC) -s -f rst -t man -A man/footer.man $< | \
777           sed -e 's/\\@/@/g' > $@
778         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN) $@; fi
779
780 man/%.html.in: man/%.gen man/footer.html
781         @test -n "$(PANDOC)" || \
782           { echo 'pandoc' not found during configure; exit 1; }
783         set -o pipefail ; \
784         $(PANDOC) -s -f rst -t html -A man/footer.html $< | \
785           sed -e 's/\\@/@/g' > $@
786
787 man/%.1: man/%.1.in $(REPLACE_VARS_SED)
788         sed -f $(REPLACE_VARS_SED) < $< > $@
789
790 man/%.7: man/%.7.in $(REPLACE_VARS_SED)
791         sed -f $(REPLACE_VARS_SED) < $< > $@
792
793 man/%.8: man/%.8.in $(REPLACE_VARS_SED)
794         sed -f $(REPLACE_VARS_SED) < $< > $@
795
796 man/%.html: man/%.html.in $(REPLACE_VARS_SED)
797         sed -f $(REPLACE_VARS_SED) < $< > $@
798
799 epydoc.conf: epydoc.conf.in Makefile
800         sed -e 's#@MODULES@#$(strip $(lint_python_code))#g' < $< > $@
801
802 vcs-version:
803         if test -d .git; then \
804           git describe > $@; \
805         elif test ! -f $@ ; then \
806           echo "Cannot auto-generate $@ file"; exit 1; \
807         fi
808
809 .PHONY: regen-vcs-version
810 regen-vcs-version:
811         set -e; \
812         cd $(srcdir); \
813         if test -d .git; then \
814           rm -f vcs-version; \
815           $(MAKE) vcs-version; \
816         fi
817
818 htools/Ganeti/HTools/Version.hs: htools/Ganeti/HTools/Version.hs.in vcs-version
819         set -e; \
820         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
821         sed -e "s/%ver%/$$VCSVER/" < $< > $@
822
823 htools/Ganeti/Constants.hs: htools/Ganeti/Constants.hs.in \
824         lib/constants.py lib/_autoconf.py $(CONVERT_CONSTANTS)
825         set -e; \
826         { cat $< ; PYTHONPATH=. $(CONVERT_CONSTANTS); } > $@
827
828 lib/_autoconf.py: Makefile vcs-version | lib/.dir
829         set -e; \
830         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
831         { echo '# This file is automatically generated, do not edit!'; \
832           echo '#'; \
833           echo ''; \
834           echo '"""Build-time configuration for Ganeti.'; \
835           echo '';\
836           echo 'This file is autogenerated by the build process.'; \
837           echo 'For any changes you need to re-run ./configure (and'; \
838           echo 'not edit by hand).'; \
839           echo ''; \
840           echo '"""'; \
841           echo ''; \
842           echo '# pylint: disable-msg=C0301,C0324'; \
843           echo '# because this is autogenerated, we do not want'; \
844           echo '# style warnings' ; \
845           echo ''; \
846           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
847           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
848           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
849           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
850           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
851           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
852           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
853           echo "SYSCONFDIR = '$(sysconfdir)'"; \
854           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
855           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
856           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
857           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
858           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
859           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
860           echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
861           echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
862           echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
863           echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
864           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
865           echo "KVM_PATH = '$(KVM_PATH)'"; \
866           echo "SOCAT_PATH = '$(SOCAT)'"; \
867           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
868           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
869           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
870           echo "TOOLSDIR = '$(toolsdir)'"; \
871           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
872           echo "PKGLIBDIR = '$(pkglibdir)'"; \
873           echo "DRBD_BARRIERS = $(DRBD_BARRIERS)"; \
874           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
875           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
876           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
877           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
878           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
879           echo "RAPI_USER = '$(RAPI_USER)'"; \
880           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
881           echo "CONFD_USER = '$(CONFD_USER)'"; \
882           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
883           echo "NODED_USER = '$(NODED_USER)'"; \
884           echo "NODED_GROUP = '$(NODED_GROUP)'"; \
885           echo "VCS_VERSION = '$$VCSVER'"; \
886           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
887           if [ "$(HTOOLS)" ]; then \
888             echo "HTOOLS = True"; \
889           else \
890             echo "HTOOLS = False"; \
891           fi; \
892         } > $@
893
894 $(REPLACE_VARS_SED): Makefile
895         set -e; \
896         { echo 's#@PREFIX@#$(prefix)#g'; \
897           echo 's#@SYSCONFDIR@#$(sysconfdir)#g'; \
898           echo 's#@LOCALSTATEDIR@#$(localstatedir)#g'; \
899           echo 's#@BINDIR@#$(bindir)#g'; \
900           echo 's#@SBINDIR@#$(sbindir)#g'; \
901           echo 's#@GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
902           echo 's#@CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
903           echo 's#@CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
904           echo 's#@CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
905           echo 's#@CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
906           echo 's#@CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
907           echo 's#@RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
908           echo 's#@RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
909           echo 's#@PKGLIBDIR@#$(pkglibdir)#g'; \
910           echo 's#@GNTMASTERUSER@#$(MASTERD_USER)#g'; \
911           echo 's#@GNTRAPIUSER@#$(RAPI_USER)#g'; \
912           echo 's#@GNTCONFDUSER@#$(CONFD_USER)#g'; \
913           echo 's#@GNTNODEDUSER@#$(NODED_USER)#g'; \
914           echo 's#@GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
915           echo 's#@GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
916           echo 's#@GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
917           echo 's#@GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
918           echo 's#@GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
919         } > $@
920
921 # Using deferred evaluation
922 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
923 daemons/ganeti-watcher: MODULE = ganeti.watcher
924 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
925 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
926
927 $(PYTHON_BOOTSTRAP): Makefile | $(all_dirfiles)
928         test -n "$(MODULE)" || { echo Missing module; exit 1; }
929         set -e; \
930         { echo '#!/usr/bin/python'; \
931           echo '# This file is automatically generated, do not edit!'; \
932           echo "# Edit $(MODULE) instead."; \
933           echo; \
934           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
935           echo; \
936           echo '# pylint: disable-msg=C0103'; \
937           echo '# C0103: Invalid name'; \
938           echo; \
939           echo 'import sys'; \
940           echo 'import $(MODULE) as main'; \
941           echo; \
942           echo '# Temporarily alias commands until bash completion'; \
943           echo '# generator is changed'; \
944           echo 'if hasattr(main, "commands"):'; \
945                 echo '  commands = main.commands # pylint: disable-msg=E1101'; \
946           echo; \
947           echo 'if __name__ == "__main__":'; \
948           echo '  sys.exit(main.Main())'; \
949         } > $@
950         chmod u+x $@
951
952 # We need to create symlinks because "make distcheck" will not install Python
953 # files when building.
954 stamp-srclinks: Makefile | $(all_dirfiles)
955         set -e; \
956         for i in $(srclink_files); do \
957                 if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
958                         $(LN_S) $(abs_top_srcdir)/$$i $$i; \
959                 fi; \
960         done
961         touch $@
962
963 .PHONY: ganeti
964 ganeti:
965         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
966
967 .PHONY: check-dirs
968 check-dirs: $(BUILT_SOURCES)
969         @set -e; \
970         find . -type d \( \( -name . \) -o \( \
971                 -name .git -o \
972                 -name autom4te.cache \
973                 \) -prune -o -print \) | { \
974                 error=; \
975                 while read dir; do \
976                         case "$$dir" in \
977                                 $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
978                                 *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
979                         esac; \
980                 done; \
981                 for dir in $(DIRS); do \
982                         if ! test -d "$$dir"; then \
983                                 echo "Directory $$dir listed in DIRS does not exist" >&2; \
984                                 error=1; \
985                         fi \
986                 done; \
987                 if test -n "$$error"; then exit 1; else exit 0; fi; \
988         }
989
990 check-local: check-dirs
991         $(CHECK_PYTHON_CODE) $(check_python_code)
992         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
993         $(CHECK_NEWS) < $(top_srcdir)/NEWS
994         expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
995         if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
996                 echo "Incorrect version in README, expected $$expver"; \
997                 exit 1; \
998         fi; \
999         if test "`sed -ne '4 p' $(top_srcdir)/doc/iallocator.rst`" != \
1000                                         "Documents Ganeti version $$expver"; then \
1001                 echo "Incorrect version in iallocator.rst, expected $$expver"; \
1002                 exit 1; \
1003         fi
1004
1005 .PHONY: hs-check
1006 hs-check: htools/test
1007         @rm -f test.tix
1008         ./htools/test
1009
1010 .PHONY: lint
1011 lint: $(BUILT_SOURCES)
1012         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1013         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
1014         cd $(top_srcdir)/qa && \
1015           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1016           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1017
1018 .PHONY: hlint
1019 hlint: $(HS_BUILT_SRCS)
1020         if tty -s; then C="-c"; else C=""; fi; \
1021         hlint --report=doc/hs-lint.html $$C htools
1022
1023 # a dist hook rule for updating the vcs-version file; this is
1024 # hardcoded due to where it needs to build the file...
1025 dist-hook:
1026         $(MAKE) regen-vcs-version && \
1027         rm -f $(top_distdir)/vcs-version && \
1028         cp -p $(srcdir)/vcs-version $(top_distdir)
1029
1030 # a distcheck hook rule for catching revision control directories
1031 distcheck-hook:
1032         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1033                 echo "Found revision control files in final archive." 1>&2; \
1034                 exit 1; \
1035         fi
1036         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1037                 echo "Found Python byte code in final archive." 1>&2; \
1038                 exit 1; \
1039         fi
1040         if find $(top_distdir) -name '*~' | grep .; then \
1041                 echo "Found backup files in final archive." 1>&2; \
1042                 exit 1; \
1043         fi
1044 # Empty files or directories should not be distributed. They can cause
1045 # unnecessary warnings for packagers. Directories used by automake during
1046 # distcheck must be excluded.
1047         if find $(top_distdir) -empty -and -not \( \
1048                         -path $(top_distdir)/_build -or \
1049                         -path $(top_distdir)/_inst \) | grep .; then \
1050                 echo "Found empty files or directories in final archive." 1>&2; \
1051                 exit 1; \
1052         fi
1053         if test -n "$(BUILD_RELEASE)" && \
1054            grep -n -H -E '^\*.*unreleased' $(top_distdir)/NEWS; then \
1055                 echo "Found unreleased version in NEWS." >&2; \
1056                 exit 1; \
1057         fi
1058
1059 # When building a release, stricter checks should be used
1060 distcheck-release dist-release: export BUILD_RELEASE = 1
1061 distcheck-release: distcheck
1062
1063 dist-release: dist
1064         set -e; \
1065         for i in $(DIST_ARCHIVES); do \
1066                 echo -n "Checking $$i ... "; \
1067                 autotools/check-tar < $$i; \
1068                 echo OK; \
1069         done
1070
1071 install-exec-local:
1072         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1073           "$(DESTDIR)${localstatedir}/log/ganeti" \
1074           "$(DESTDIR)${localstatedir}/run/ganeti"
1075
1076 # To avoid conflicts between directory names and other targets, a file inside
1077 # the directory is used to ensure its existence.
1078 %.dir:
1079         @mkdir_p@ $* && touch $@
1080
1081 .PHONY: apidoc
1082 if WANT_HTOOLSAPIDOC
1083 apidoc: py-apidoc hs-apidoc
1084 else
1085 apidoc: py-apidoc
1086 endif
1087
1088 .PHONY: py-apidoc
1089 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(BUILT_SOURCES)
1090         $(RUN_IN_TEMPDIR) epydoc -v \
1091                 --conf $(CURDIR)/epydoc.conf \
1092                 --output $(CURDIR)/$(APIDOC_PY_DIR)
1093
1094 .PHONY: hs-apidoc
1095 hs-apidoc: $(HS_BUILT_SRCS)
1096         @test -n "$(HSCOLOUR)" || \
1097             { echo 'HsColour' not found during configure; exit 1; }
1098         @test -n "$(HADDOCK)" || \
1099             { echo 'haddock' not found during configure; exit 1; }
1100         rm -rf $(APIDOC_HS_DIR)/*
1101         @mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/HTools
1102         $(HSCOLOUR) -print-css > $(APIDOC_HS_DIR)/Ganeti/hscolour.css
1103         ln -s ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/HTools/hscolour.css
1104         set -e ; \
1105         cd htools; \
1106         if [ "$(HTOOLS_NOCURL)" ]; \
1107         then OPTGHC="--optghc=$(HTOOLS_NOCURL)"; \
1108         else OPTGHC=""; \
1109         fi; \
1110         RELSRCS="$(HS_LIB_SRCS:htools/%=%)"; \
1111         for file in $$RELSRCS; do \
1112                 hfile=`echo $$file|sed 's/\\.hs$$//'`.html; \
1113                 $(HSCOLOUR) -css -anchor $$file > ../$(APIDOC_HS_DIR)/$$hfile ; \
1114         done ; \
1115         $(HADDOCK) --odir ../$(APIDOC_HS_DIR) --html --ignore-all-exports -w \
1116                 -t ganeti-htools -p haddock-prologue \
1117                 --source-module="%{MODULE/.//}.html" \
1118                 --source-entity="%{MODULE/.//}.html#%{NAME}" \
1119                 $$OPTGHC \
1120                 $(filter-out Ganeti/HTools/ExtLoader.hs,$(HS_LIB_SRCS:htools/%=%))
1121
1122 .PHONY: TAGS
1123 TAGS: $(BUILT_SOURCES)
1124         rm -f TAGS
1125         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
1126           -path './daemons/ganeti-*' -o -path './tools/*' -o \
1127           -path './qa/*.py' | \
1128           etags -l python -
1129
1130 .PHONY: coverage
1131 if WANT_HTOOLS
1132 coverage: py-coverage hs-coverage
1133 else
1134 coverage: py-coverage
1135 endif
1136
1137 .PHONY: py-coverage
1138 py-coverage: $(BUILT_SOURCES) $(python_tests)
1139         set -e; \
1140         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
1141         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
1142         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
1143         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/gen-coverage \
1144         $(python_tests)
1145
1146 .PHONY: hs-coverage
1147 hs-coverage: $(haskell_tests)
1148         cd htools && rm -f *.tix *.mix && ./test
1149         mkdir -p $(COVERAGE_HS_DIR)
1150         hpc markup --destdir=$(COVERAGE_HS_DIR) htools/test $(HPCEXCL)
1151         hpc report htools/test $(HPCEXCL)
1152         ln -sf hpc_index.html $(COVERAGE_HS_DIR)/index.html
1153
1154 # Special "kind-of-QA" target for htools, needs special setup (all
1155 # tools compiled with -fhpc)
1156 .PHONY: live-test
1157 live-test: all
1158         set -e ; \
1159         cd htools; \
1160         rm -f .hpc; ln -s ../.hpc .hpc; \
1161         rm -f *.tix *.mix; \
1162         ./live-test.sh; \
1163         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:htools/%=%)) \
1164           --output=live-test.tix ; \
1165         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
1166         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
1167                 --srcdir=.. $(HPCEXCL) ; \
1168         hpc report --srcdir=.. live-test $(HPCEXCL)
1169
1170 commit-check: distcheck lint apidoc
1171
1172 -include ./Makefile.local
1173
1174 # vim: set noet :